/****************************************************************************
 * apps/testing/testsuites/kernel/mm/cases/mm_test_005.c
 *
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.  The
 * ASF licenses this file to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 *
 ****************************************************************************/

/****************************************************************************
 * Included Files
 ****************************************************************************/

#include <nuttx/config.h>
#include <stdlib.h>
#include <syslog.h>
#include <inttypes.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <stdint.h>
#include <stdarg.h>
#include <stddef.h>
#include <setjmp.h>
#include <cmocka.h>
#include "MmTest.h"

/****************************************************************************
 * Public Functions
 ****************************************************************************/

/****************************************************************************
 * Name: TestNuttxMm05
 ****************************************************************************/

void test_nuttx_mm05(FAR void **state)
{
  int i = 0;
  int flag = 0;
  char *ptr = NULL;
  char *temp_ptr = NULL;

  ptr = temp_ptr = zalloc(1024 * sizeof(char));
  assert_non_null(temp_ptr);

  for (i = 0; i < 1024; i++)
    {
      if (*temp_ptr++ != 0)
        {
          flag = 1;
        }
    }

  free(ptr);
  assert_int_equal(flag, 0);
}
